#!BuildIgnore:  post-build-checks brp-check-suse
AutoReqProv: 	on

Name: 		amanda_enterprise
Version: 	2.6.3
Release: 	19.2
Summary: 	Network Disk Archiver
Group: 		Applications/Archiving
License: 	GPL
Source0: 	%{name}-%{version}.tar.bz2 
Source1:	%{name}-rpmlintrc
Source2:	xinetd_centos
Patch0:		amanda_enterprise-Werror.patch
Group: 		Applications/Archiving
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildRequires: 	mailx autoconf flex dump readline-devel curl glib2-devel star 
Requires: 	star
Requires: 	dump
Requires: 	mailx
Requires: 	fileutils
Requires: 	gnuplot
Requires: 	curl >= 7.10.0
Requires: 	xinetd
Requires:	perl
Requires: 	tar 
%if 0%{?centos_version}
Requires: 	initscripts
%endif

Provides: 	amanda_enterprise-backup_client, amanda_enterprise-backup_server
Obsoletes: 	amanda, amanda-server, amanda-client




%description
Amanda Enterprise Backup



%define build_srpm 0
%{?srpm_only: %define build_srpm 1}

%define packer %(%{__id_u} -n)

%{!?amanda_version: %define amanda_version 2.6.3}
%{!?amanda_release: %define amanda_release 1}
%define amanda_version_info "Amanda Enterprise Edition - version %{amanda_version}"
%define amanda_user amandabackup
%define amanda_group disk
%define udpportrange "700,790"
%define tcpportrange "11000,11100"
%define low_tcpportrange "700,740"


%if 0%{?suse_version}
        %define dist SuSE
        %define disttag suse
%endif


%package backup_client
Summary: 	The Amanda Backup and Archiving Client - Amanda Enterprise Edition
Group: 		Applications/Archiving
Requires: 	fileutils

%if 0%{?centos_version}
Requires: 	initscripts
%endif
Requires: 	xinetd
Requires: 	perl
Requires: 	tar 
Obsoletes: 	amanda-backup_client
Provides:	amanda-backup_client = %{version}
Conflicts: 	amanda_enterprise-backup_server

%description backup_client
This package contains the Amanda enterprise client.  
The amanda_enterprise-backup_client package needs to be installed on every 
system that is being backed up.



%package backup_server
Summary: 	The Amanda Backup and Archiving Server - Amanda Enterprise Edition
Group: 		Applications/Archiving
%if 0%{?centos_version}
Requires: 	initscripts
%endif
Requires: 	xinetd
Requires: 	perl
Requires: 	tar
Obsoletes: 	amanda-backup_server
Provides:	amanda-backup_server = %{version}

%description backup_server
This package contains the Amanda enterprise server.  The 
amanda_enterprise-backup_server package should be installed on the 
Amanda server, i.e. the machine attached to backup media (such as a 
tape drive or disk drives) where backups will be written.  The 
amanda_enterprise-backup_server package includes Amanda enterprise
client.


# --- Directory setup ---

# Configure directories:
%define PREFIX			/usr
%define EPREFIX			%{PREFIX}
%define BINDIR			%{EPREFIX}/bin
%define SBINDIR			%{EPREFIX}/sbin
%define LIBEXECDIR      	%{EPREFIX}/libexec
%define DATADIR			%{PREFIX}/share
%define SYSCONFDIR		/etc
%define LOCALSTATEDIR		/var
%define AMANDAHOMEDIR		/var/lib/amanda
#
%ifarch x86_64
%define LIBDIR			%{EPREFIX}/lib64
%else
%define LIBDIR			%{EPREFIX}/lib
%endif


%define INCLUDEDIR		%{PREFIX}/include
%define INFODIR			%{PREFIX}/info
%define MANDIR			%{DATADIR}/man
%define LOGDIR			/var/log/amanda

# Installation directories:
%define ROOT_SBINDIR		%{buildroot}/%{SBINDIR}
%define ROOT_LIBEXECDIR         %{buildroot}/%{LIBEXECDIR}
%define ROOT_LIBDIR             %{buildroot}/%{LIBDIR}
%define ROOT_DATADIR		%{buildroot}/%{DATADIR}
%define ROOT_SYSCONFDIR		%{buildroot}/%{SYSCONFDIR}
%define ROOT_AMANDAHOMEDIR	%{buildroot}/%{AMANDAHOMEDIR}
%define ROOT_INFODIR		%{buildroot}/%{INFODIR}
%define ROOT_MANDIR		%{buildroot}/%{MANDIR}
%define ROOT_LOGDIR		%{buildroot}/%{LOGDIR}

# --- Unpack and apply patches (if any) ---

%prep
%setup
%patch0
# --- Configure and compile ---

%build
%define config_user %{amanda_user}
%define config_group %{amanda_group}

%if 0%{?suse_version} >= 1030

%ifarch x86_64
%define build_host x86_64-unknown-linux
CFLAGS="" CXXFLAGS="" \
%else
%define build_host i386-unknown-linux
CFLAGS="" CXXFLAGS="" \
%endif

%else

%ifarch x86_64 
%define build_host x86_64-unknown-linux
CFLAGS="%{optflags} -m64 -g" CXXFLAGS="%{optflags} -m64" \
%else
%define build_host i386-unknown-linux
CFLAGS="%{optflags} -m32 -g" CXXFLAGS="%{optflags} -m32" \
%endif

%endif
./configure \
	--build=%{build_host} \
	--prefix=%{PREFIX} \
	--bindir=%{BINDIR} \
	--sbindir=%{SBINDIR} \
	--datadir=%{DATADIR} \
	--libdir=%{LIBDIR} \
	--sysconfdir=%{SYSCONFDIR} \
	--sharedstatedir=%{LOCALSTATEDIR} \
	--localstatedir=%{LOCALSTATEDIR} \
	--includedir=%{INCLUDEDIR} \
	--infodir=%{INFODIR} \
	--mandir=%{MANDIR} \
	--with-star=/usr/bin/star \
	--with-dump=/sbin/dump \
	--with-gnuplot=/usr/bin/gnuplot \
	--with-gnutar=/bin/tar \
	--with-gnutar-listdir=%{AMANDAHOMEDIR}/gnutar-lists \
	--with-dumperdir=%{LIBEXECDIR} \
	--with-index-server=localhost \
	--with-tape-server=localhost \
	--with-user=%{config_user} \
	--with-group=%{config_group} \
	--with-owner=%{packer} -with-fqdn \
	--with-bsd-security \
	--with-bsdtcp-security \
	--with-bsdudp-security \
	--with-ssh-security \
	--with-udpportrange=%{udpportrange} \
	--with-tcpportrange=%{tcpportrange} \
	--with-low-tcpportrange=%{low_tcpportrange} \
	--with-debugging=%{LOGDIR} \
        --with-assertions \
	--with-buffered-dump \
	--without-ipv6 \
	--disable-devpay \
	--disable-installperms

%{__make}

# --- Install to buildroot ---

%install

mkdir -p %{buildroot}/{etc,var/log}
mkdir -p %{ROOT_SYSCONFDIR}/xinetd.d
mkdir -p %{ROOT_SYSCONFDIR}/amanda
mkdir -p %{ROOT_AMANDAHOMEDIR}/gnutar-lists
mkdir -p %{ROOT_LOGDIR}
%{__install} -p -m 0755 %{SOURCE2} %{buildroot}/etc/xinetd.d/amandaclient
echo "backup1-muc.internetx.de amandabackup amdump" > %{ROOT_AMANDAHOMEDIR}/.amandahosts

make DESTDIR=%{buildroot} install

rm -rf %{ROOT_DATADIR}/amanda_enterprise
# rm -f %{ROOT_AMANDAHOMEDIR}/example/inetd.conf.amandaclient

echo "%{amanda_version_info}" >%{ROOT_AMANDAHOMEDIR}/amanda-release

# --- Clean up buildroot ---

%clean
if [ "%{buildroot}" != "/" ]; then
	if [ -d "%{buildroot}" ] ; then
		rm -rf %{buildroot}
	fi
else
	echo "BuildRoot was somehow set to / !"
	exit -1
fi

# --- Pre/post (un)installation scripts ---

%pre
TMPFILE=`mktemp /tmp/rpm-amanda_enterprise.XXXXXXXXXXX`
if [ $? -ne 0 ]; then
	echo "Unable to mktemp!" 1>&2
	exit 1
fi
LOGDIR="%{LOGDIR}"
INSTALL_LOG="${LOGDIR}/install.log"
INSTALL_ERR="${LOGDIR}/install.err"

echo "`date +'%b %e %Y %T'`: Preparing to install: %{amanda_version_info}" >${TMPFILE}

# Check for the 'amanda' user
echo "`date +'%b %e %Y %T'`: Checking for '%{amanda_user}' user..." >>${TMPFILE}

if [ "`id -u %{amanda_user} > /dev/null 2>&1 && echo 0 || echo 1`" != "0" ] ; then
	useradd -c "Amanda" -g disk -d %{AMANDAHOMEDIR} -s /bin/sh %{amanda_user}
	if [ %{dist} = "SuSE" ]; then
		PASSWD_EXIT=$?
	else
		# Lock the amanda account until admin sets password
		passwd -l %{amanda_user} >>/dev/null
		PASSWD_EXIT=$?
	fi
	if [ ${PASSWD_EXIT} -eq 0 ] ; then
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  The '%{amanda_user}; user account has been successfully created." >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  Furthermore, the account has been automatically locked for you" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  for security purposes.  Once a password for the  '%{amanda_user}'" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  account has been set, the user can be unlocked by issuing" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  the following command as root.:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  # passwd -u %{amanda_user}" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  If this is not a new installation of Amanda and you have" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  pre-existing Amanda configurations in %{SYSCONFDIR}/amanda" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  you should ensure that 'dumpuser' is set to '%{amanda_user}'" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  in those configurations.  Additionally, you should ensure" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  that %{AMANDAHOMEDIR}/.amandahosts on your client systems" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  is properly configured to allow connections for the user" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  '%{amanda_user}'." >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		PASSWD_OK=0
	else
		echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!                                                       !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  The '%{amanda_user}' user account for this system has been   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  created, however the user has no password set. For   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  security purposes this account  is normally locked   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  after creation.  Unfortunately,  when locking this   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  account an error occurred.  To ensure the security   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  of your system  you should set a password  for the   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  user account '%{amanda_user}' immediately!  To set  such a   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  password, please issue the following command.:       !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!                                                       !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!   # passwd %{amanda_user}                                   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!                                                       !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
		PASSWD_OK=1
	fi
else
	# log information about 'amanda' user parameters
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  The Amanda backup software is configured to operate as the" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  user '%{amanda_user}'.  This user exists on your system and has not" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  been modified.  To ensure that Amanda functions properly," >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  please see that the following parameters are set for that" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  user.:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  SHELL:          /bin/sh" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  HOME:           %{AMANDAHOMEDIR}" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  Default group:  %{amanda_group}" >>${TMPFILE}
       		echo "`date +'%b %e %Y %T'`:  Verifying %{amanda_user} parameters :" >>${TMPFILE}
        if [ "`id -gn %{amanda_user}`" != "disk" ] ; then
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! user 'amandabackup' is not part of the disk group,Pl  !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! make sure it is corrected before start using Amanda   !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
        else
                echo "`date +'%b %e %Y %T'`:  Verified group name of user 'amandabackup'" >>${TMPFILE}
        fi

        if [ "`grep ^%{amanda_user} /etc/passwd|cut -d: -f7`" != "/bin/sh" ] ; then
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! user 'amandabackup' default shell should be set to    !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! /bin/sh, pl correct before start using Amanda         !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
        else
                echo "`date +'%b %e %Y %T'`:  Verified Default shell for user 'amandabackup'" >>${TMPFILE}
        fi

        if [ "`grep ^%{amanda_user} /etc/passwd|cut -d: -f6`" != "%{AMANDAHOMEDIR}" ] ; then
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! user 'amandabackup' home directory should be set to   !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! %{AMANDAHOMEDIR} Pl correct before using Amanda       !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
        else
                echo "`date +'%b %e %Y %T'`:  Verified Default home directory for user amandabackup" >>${TMPFILE}
        fi
	echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
	PASSWD_OK=0
fi
if [ -d %{AMANDAHOMEDIR} ] ; then
	echo -n "`date +'%b %e %Y %T'`:  Checking ownership of '%{AMANDAHOMEDIR}'... " >>${TMPFILE}
	if [ "`ls -dl %{AMANDAHOMEDIR} | awk '//{split($_,x); print x[3]}'`" = "%{amanda_user}" ] && \
	   [ "`ls -dl %{AMANDAHOMEDIR} | awk '//{split($_,x); print x[4]}'`" = "%{amanda_group}" ] ; then
		echo "correct." >>${TMPFILE}
		VARLIB_OK=0
	else
		echo "incorrect!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  Please ensure that the directory '%{AMANDAHOMEDIR}' is owned by" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  the user '%{amanda_user}' and group '%{amanda_group}'." >>${TMPFILE}
		VARLIB_OK=1
	fi
elif
	VARLIB_OK=0
fi
echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
if [ ! -e ${LOGDIR} ] ; then
	# create log directory
	mkdir -p -m 0750 ${LOGDIR} >>${TMPFILE} 2>&1
	chown %{amanda_user}:%{amanda_group} ${LOGDIR} >>${TMPFILE} 2>&1
elif [ ! -d ${LOGDIR} ] ; then
	mv ${LOGDIR} ${LOGDIR}.rpmsave >>${TMPFILE} 2>&1
	mkdir -p -m 0750 ${LOGDIR} >>${TMPFILE} 2>
	chown %{amanda_user}:%{amanda_group} ${LOGDIR} >>${TMPFILE} 2>&1
	mv ${LOGDIR}.rpmsave ${LOGDIR}/ >>${TMPFILE} 2>&1
fi

if [ ${PASSWD_OK} -eq 1 ] || [ ${VARLIB_OK} -eq 1 ] ; then
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_ERR}
	echo "Please review '${INSTALL_ERR}' to correct errors which have prevented the Amanda installaton." >&2
	echo "Amanda installation log can be found in '${INSTALL_LOG}' and errors (if any) in '${INSTALL_ERR}'."
	exit 1
else
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi

echo "`date +'%b %e %Y %T'`: === Amanda Enterprise Edition installation started. ===" >${TMPFILE}

cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}
if [ -f "${TMPFILE}" ]; then
	rm -f "${TMPFILE}"
fi

%post
TMPFILE=`mktemp /tmp/rpm-amanda_enterprise.XXXXXXXXXXX`
if [ $? -ne 0 ]; then
	echo "Unable to mktemp!" 1>&2
	exit 1
fi
LOGDIR="%{LOGDIR}"
INSTALL_LOG="${LOGDIR}/install.log"
INSTALL_ERR="${LOGDIR}/install.err"

echo -n "`date +'%b %e %Y %T'`: Updating library cache..." >${TMPFILE}
/sbin/ldconfig >>${TMPFILE} 2>&1
echo "done." >>${TMPFILE}
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

if [ -e /etc/xinetd.d ] && [ -d /etc/xinetd.d ] ; then
	if [ ! -f /etc/xinetd.d/amandaserver ] ; then
		cp %{AMANDAHOMEDIR}/example/xinetd.amandaserver /etc/xinetd.d/amandaserver
		chmod 0644 /etc/xinetd.d/amandaserver >>${TMPFILE} 2>&1
		if [ -f /etc/xinetd.d/amandaclient ] ; then
			rm /etc/xinetd.d/amandaclient
		fi
		echo -n "`date +'%b %e %Y %T'`: Reloading xinetd configuration..." >${TMPFILE}
		if [ "%{xinetd_reload}" == "reload" ] ; then
			/etc/init.d/xinetd %{xinetd_reload} >>${TMPFILE} 2>&1
			ret_val=$?
			if [ ${ret_val} -ne 0 ] ; then
				echo -n "reload failed.  Attempting restart..." >>${TMPFILE}
				/etc/init.d/xinetd restart >>${TMPFILE} 2>&1
				ret_val=$?
			fi
		else
			/etc/init.d/xinetd %{xinetd_reload} >>${TMPFILE} 2>&1
			ret_val=$?
		fi
		if [ ${ret_val} -eq 0 ] ; then
			echo "success." >>${TMPFILE}
			cat ${TMPFILE}
			cat ${TMPFILE} >>${INSTALL_LOG}
		else
			echo "failed.  Please check your system logs." >>${TMPFILE}
			cat ${TMPFILE} 1>&2
			cat ${TMPFILE} >>${INSTALL_ERR}
		fi
	fi
fi

echo "`date +'%b %e %Y %T'`: Installing '%{SYSCONFDIR}/amandates'." >${TMPFILE}
ret_val=0
if [ ! -f %{SYSCONFDIR}/amandates ] ; then
	touch %{SYSCONFDIR}/amandates >>${TMPFILE} 2>&1
	ret_val=$?
	if [ ${ret_val} -eq 0 ]; then
		echo "`date +'%b %e %Y %T'`: The file '%{SYSCONFDIR}/amandates' has been created." >>${TMPFILE}
	fi
fi
if [ ${ret_val} -eq 0 ]; then
	echo "`date +'%b %e %Y %T'`: Ensuring correct permissions for '%{SYSCONFDIR}/amandates'." >>${TMPFILE}
	chown %{amanda_user}:%{amanda_group} %{SYSCONFDIR}/amandates >>${TMPFILE} 2>&1
	chmod 0640 %{SYSCONFDIR}/amandates >>${TMPFILE} 2>&1
	if [ -x /sbin/restorecon ] ; then
	      /sbin/restorecon %{SYSCONFDIR}/amandates  >>${TMPFILE} 2>&1
	fi
fi
if [ ${ret_val} -eq 0 ]; then
	echo "`date +'%b %e %Y %T'`: '%{SYSCONFDIR}/amandates' Installation successful." >>${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
else
	echo "`date +'%b %e %Y %T'`: '%{SYSCONFDIR}/amandates' Installation failed." >>${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_ERR}
fi


# Install .gnupg directory
echo "`date +'%b %e %Y %T'`: Installing '%{AMANDAHOMEDIR}/.gnupg'." >${TMPFILE}
ret_val=0
if [ ! -d %{AMANDAHOMEDIR}/.gnupg ] ; then
	echo "`date +'%b %e %Y %T'`: '%{AMANDAHOMEDIR}/.gnupg' will be created." >>${TMPFILE}
	mkdir -p %{AMANDAHOMEDIR}/.gnupg >>${TMPFILE} 2>&1
	ret_val=$?
	if [ ${ret_val} -eq 0 ]; then
		echo "`date +'%b %e %Y %T'`: The directory '%{AMANDAHOMEDIR}/.gnupg' created successfully." >>${TMPFILE}
	else
		echo "`date +'%b %e %Y %T'`: The directory '%{AMANDAHOMEDIR}/.gnupg' creation failed." >>${TMPFILE}
	fi
fi
if [ ${ret_val} -eq 0 ]; then
	echo "`date +'%b %e %Y %T'`: Ensuring correct permissions for '%{SYSCONFDIR}/.gnupg'." >>${TMPFILE}
	chown %{amanda_user}:%{amanda_group} %{AMANDAHOMEDIR}/.gnupg >>${TMPFILE} 2>&1
	ret_val=$?
	if [ ${ret_val} -eq 0 ]; then
		chmod 700 %{AMANDAHOMEDIR}/.gnupg >>${TMPFILE} 2>&1
		ret_val=$?
	fi
fi
if [ ${ret_val} -eq 0 ]; then
	echo "`date +'%b %e %Y %T'`: '%{AMANDAHOMEDIR}/.gnupg' Installation successful." >>${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
else
	echo "`date +'%b %e %Y %T'`: '%{AMANDAHOMEDIR}/.gnupg' Installation failed." >>${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_ERR}
fi

# Install .amandahosts to server
echo "`date +'%b %e %Y %T'`: Checking '%{AMANDAHOMEDIR}/.amandahosts' file." >${TMPFILE}
if [ ! -f %{AMANDAHOMEDIR}/.amandahosts ] ; then
	touch %{AMANDAHOMEDIR}/.amandahosts >>${TMPFILE} 2>&1
fi
for host in localhost localhost.localdomain ; do
	if [ -z "`grep \"^${host}[[:blank:]]\+root[[:blank:]]\+amindexd[[:blank:]]\+amidxtaped\" %{AMANDAHOMEDIR}/.amandahosts`" ] ; then
		echo "${host}   root amindexd amidxtaped" >>%{AMANDAHOMEDIR}/.amandahosts
	fi
	if [ -z "`grep \"^${host}[[:blank:]]\+%{amanda_user}[[:blank:]]\+amdump\" %{AMANDAHOMEDIR}/.amandahosts`" ] ; then
		echo "${host}   %{amanda_user} amdump" >>%{AMANDAHOMEDIR}/.amandahosts
	fi
done
chown %{amanda_user}:%{amanda_group} %{AMANDAHOMEDIR}/.amandahosts >>${TMPFILE} 2>&1
chmod 0600 %{AMANDAHOMEDIR}/.amandahosts >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

# SSH RSA key generation for amdump
KEYDIR="%{AMANDAHOMEDIR}/.ssh"
KEYFILE="id_rsa_amdump"
COMMENT="%{amanda_user}@server"
if [ ! -d ${KEYDIR} ] ; then
	if [ -f ${KEYDIR} ] ; then
		echo "`date +'%b %e %Y %T'`: Directory '${KEYDIR}' exists as a file.  Renaming to '${KEYDIR}.rpmsave'." >${TMPFILE}
		mv ${KEYDIR} ${KEYDIR}.rpmsave
		cat ${TMPFILE}
		cat ${TMPFILE} >>${INSTALL_LOG}
	fi
	echo "`date +'%b %e %Y %T'`: Creating directory '${KEYDIR}'." >${TMPFILE}
	mkdir -p ${KEYDIR} >>${TMPFILE} 2>&1
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi
if [ ! -f ${KEYDIR}/${KEYFILE} ] ; then
	echo "`date +'%b %e %Y %T'`: Creating ssh RSA key in '${KEYDIR}/${KEYFILE}'" >${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
	ssh-keygen -q -C $COMMENT -t rsa -f ${KEYDIR}/${KEYFILE} -N '' >>${TMPFILE} 2>&1
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi
echo "`date +'%b %e %Y %T'`: Setting ownership and permissions for '${KEYDIR}' and '${KEYDIR}/${KEYFILE}*'" >${TMPFILE}
chown %{amanda_user}:%{amanda_group} ${KEYDIR} ${KEYDIR}/${KEYFILE}* >>${TMPFILE} 2>&1
chmod 0750 ${KEYDIR} >>${TMPFILE} 2>&1
chmod 0600 ${KEYDIR}/${KEYFILE}* >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

# SSH RSA key generation on client for amrecover
KEYDIR="%{AMANDAHOMEDIR}/.ssh"
KEYFILE="id_rsa_amrecover"
COMMENT="root@client"
if [ ! -d ${KEYDIR} ] ; then
	if [ -f ${KEYDIR} ] ; then
		echo "`date +'%b %e %Y %T'`: Directory '${KEYDIR}' exists as a file.  Renaming to '${KEYDIR}.rpmsave'." >${TMPFILE}
		mv ${KEYDIR} ${KEYDIR}.rpmsave >>${TMPFILE} 2>&1
		cat ${TMPFILE}
		cat ${TMPFILE} >>${INSTALL_LOG}
	fi
	echo "`date +'%b %e %Y %T'`: Creating directory '${KEYDIR}'." >${TMPFILE}
	mkdir -p ${KEYDIR} >>${TMPFILE} 2>&1
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi
if [ ! -f ${KEYDIR}/${KEYFILE} ] ; then
	echo "`date +'%b %e %Y %T'`: Creating ssh RSA key in '${KEYDIR}/${KEYFILE}'" >${TMPFILE}
	ssh-keygen -q -C $COMMENT -t rsa -f ${KEYDIR}/${KEYFILE} -N '' >>${TMPFILE} 2>&1
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi
echo "`date +'%b %e %Y %T'`: Setting permissions for '${KEYDIR}'" >${TMPFILE}
chown %{amanda_user}:%{amanda_group} ${KEYDIR} >>${TMPFILE} 2>&1
chmod 0750 ${KEYDIR} >>${TMPFILE} 2>&1
chmod 0600 ${KEYDIR}/${KEYFILE}* >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

# environment variables (~amandabackup/.profile)
echo "`date +'%b %e %Y %T'`: Checking for '%{AMANDAHOMEDIR}/.profile' and ensuring correct environment." >${TMPFILE}
if [ ! -f %{AMANDAHOMEDIR}/.profile ] ; then
	touch %{AMANDAHOMEDIR}/.profile >>${TMPFILE} 2>&1
fi
if [ -z "`grep PATH %{AMANDAHOMEDIR}/.profile | grep '%{SBINDIR}'`" ] ; then
	echo "export PATH=\"\$PATH:%{SBINDIR}\"" >>%{AMANDAHOMEDIR}/.profile
fi
echo "`date +'%b %e %Y %T'`: Setting ownership and permissions for '%{AMANDAHOMEDIR}/.profile'" >>${TMPFILE}
chown %{amanda_user}:%{amanda_group} %{AMANDAHOMEDIR}/.profile >>${TMPFILE} 2>&1
chmod 0640 %{AMANDAHOMEDIR}/.profile >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

# echo "`date +'%b %e %Y %T'`: Creating en_ZM locale"  >>${TMPFILE}
# localedef -i /usr/share/i18n/locales/en_US -f ISO-8859-1 en_ZM >>${TMPFILE} 2>&1
# cat ${TMPFILE}
# cat ${TMPFILE} >>${INSTALL_LOG}


echo "`date +'%b %e %Y %T'`: === Amanda installation complete. ===" >${TMPFILE}

cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}
if [ -f "${TMPFILE}" ]; then
	rm -f "${TMPFILE}"
fi

echo "Amanda installation log can be found in '${INSTALL_LOG}' and errors (if any) in '${INSTALL_ERR}'."
%postun
/sbin/ldconfig
%pre backup_server
TMPFILE=`mktemp /tmp/rpm-amanda_enterprise.XXXXXXXXXXX`
if [ $? -ne 0 ]; then
	echo "Unable to mktemp!" 1>&2
	exit 1
fi

LOGDIR="%{LOGDIR}"
INSTALL_LOG="${LOGDIR}/install.log"
INSTALL_ERR="${LOGDIR}/install.err"

echo "`date +'%b %e %Y %T'`: Preparing to install: %{amanda_version_info}" >${TMPFILE}

# Check for the 'amanda' user
echo "`date +'%b %e %Y %T'`: Checking for '%{amanda_user}' user..." >>${TMPFILE}
if [ "`id -u %{amanda_user} > /dev/null 2>&1 && echo 0 || echo 1`" != "0" ] ; then
	useradd -c "Amanda" -g disk -d %{AMANDAHOMEDIR} -s /bin/sh %{amanda_user}
	if [ %{dist} = "SuSE" ]; then
		PASSWD_EXIT=$?
	else
		# Lock the amanda account until admin sets password
		passwd -l %{amanda_user} >>/dev/null
		PASSWD_EXIT=$?
	fi
	if [ ${PASSWD_EXIT} -eq 0 ] ; then
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  The '%{amanda_user}; user account has been successfully created." >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  Furthermore, the account has been automatically locked for you" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  for security purposes.  Once a password for the  '%{amanda_user}'" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  account has been set, the user can be unlocked by issuing" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  the following command as root.:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  # passwd -u %{amanda_user}" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  If this is not a new installation of Amanda and you have" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  pre-existing Amanda configurations in %{SYSCONFDIR}/amanda" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  you should ensure that 'dumpuser' is set to '%{amanda_user}'" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  in those configurations.  Additionally, you should ensure" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  that %{AMANDAHOMEDIR}/.amandahosts on your client systems" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  is properly configured to allow connections for the user" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  '%{amanda_user}'." >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		PASSWD_OK=0
	else
		echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!                                                       !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  The '%{amanda_user}' user account for this system has been   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  created, however the user has no password set. For   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  security purposes this account  is normally locked   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  after creation.  Unfortunately,  when locking this   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  account an error occurred.  To ensure the security   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  of your system  you should set a password  for the   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  user account '%{amanda_user}' immediately!  To set  such a   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  password, please issue the following command.:       !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!                                                       !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!   # passwd %{amanda_user}                                     !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!                                                       !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
		PASSWD_OK=1
	fi
else
	# log information about 'amanda' user parameters
	echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
	echo "`date +'%b %e %Y %T'`:  The Amanda backup software is configured to operate as the" >>${TMPFILE}
	echo "`date +'%b %e %Y %T'`:  user '%{amanda_user}'.  This user exists on your system and has not" >>${TMPFILE}
	echo "`date +'%b %e %Y %T'`:  been modified.  To ensure that Amanda functions properly," >>${TMPFILE}
	echo "`date +'%b %e %Y %T'`:  please see that the following parameters are set for that" >>${TMPFILE}
	echo "`date +'%b %e %Y %T'`:  user.:" >>${TMPFILE}
	echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
	echo "`date +'%b %e %Y %T'`:  SHELL:          /bin/sh" >>${TMPFILE}
	echo "`date +'%b %e %Y %T'`:  HOME:           %{AMANDAHOMEDIR}" >>${TMPFILE}
	echo "`date +'%b %e %Y %T'`:  Default group:  %{amanda_group}" >>${TMPFILE}
        echo "`date +'%b %e %Y %T'`:  Verifying %{amanda_user} parameters :" >>${TMPFILE}

        if [ "`id -gn %{amanda_user}`" != "disk" ] ; then
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! user 'amandabackup' is not part of the disk group,Pl  !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! make sure it is corrected before start using Amanda   !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
        else
                echo "`date +'%b %e %Y %T'`:  Verified group name of user 'amandabackup'" >>${TMPFILE}
        fi

        if [ "`grep ^%{amanda_user} /etc/passwd|cut -d: -f7`" != "/bin/sh" ] ; then
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! user 'amandabackup' default shell should be set to    !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! /bin/sh, pl correct before start using Amanda         !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
        else
                echo "`date +'%b %e %Y %T'`:  Verified Default shell for user 'amandabackup'" >>${TMPFILE}
        fi

        if [ "`grep ^%{amanda_user} /etc/passwd|cut -d: -f6`" != "%{AMANDAHOMEDIR}" ] ; then
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! user 'amandabackup' home directory should be set to   !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! %{AMANDAHOMEDIR} Pl correct before using Amanda       !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
        else
                echo "`date +'%b %e %Y %T'`:  Verified Default home directory for user amandabackup" >>${TMPFILE}
        fi
	echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
	PASSWD_OK=0
fi
if [ -d %{AMANDAHOMEDIR} ] ; then
	echo -n "`date +'%b %e %Y %T'`:  Checking ownership of '%{AMANDAHOMEDIR}'... " >>${TMPFILE}
	if [ "`ls -dl %{AMANDAHOMEDIR} | awk '//{split($_,x); print x[3]}'`" = "%{amanda_user}" ] && \
	   [ "`ls -dl %{AMANDAHOMEDIR} | awk '//{split($_,x); print x[4]}'`" = "%{amanda_group}" ] ; then
		echo "correct." >>${TMPFILE}
		VARLIB_OK=0
	else
		echo "incorrect!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  Please ensure that the directory '%{AMANDAHOMEDIR}' is owned by" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  the user '%{amanda_user}' and group '%{amanda_group}'." >>${TMPFILE}
		VARLIB_OK=1
	fi
else
	VARLIB_OK=0
fi
echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}

if [ ! -e ${LOGDIR} ] ; then
	# create log directory
	mkdir -p -m 0750 ${LOGDIR} >>${TMPFILE} 2>&1
	chown %{amanda_user}:%{amanda_group} ${LOGDIR} >>${TMPFILE} 2>&1
elif [ ! -d ${LOGDIR} ] ; then
	mv ${LOGDIR} ${LOGDIR}.rpmsave >>${TMPFILE} 2>&1
	mkdir -p -m 0750 ${LOGDIR} >>${TMPFILE} 2>&1
	chown %{amanda_user}:%{amanda_group} ${LOGDIR} >>${TMPFILE} 2>&1
	mv ${LOGDIR}.rpmsave ${LOGDIR}/ >>${TMPFILE} 2>&1
fi
if [ ${PASSWD_OK} -eq 1 ] || [ ${VARLIB_OK} -eq 1 ] ; then
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_ERR}
	echo "Please review '${INSTALL_ERR}' to correct errors which have prevented the Amanda installaton." >&2
	echo "Amanda installation log can be found in '${INSTALL_LOG}' and errors (if any) in '${INSTALL_ERR}'."
	exit 1
else
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi

echo "`date +'%b %e %Y %T'`: === Amanda Enterprise backup server installation started. ===" >${TMPFILE}

cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}
if [ -f "${TMPFILE}" ]; then
	rm -f "${TMPFILE}"
fi
%post backup_server
TMPFILE=`mktemp /tmp/rpm-amanda_enterprise.XXXXXXXXXXX`
if [ $? -ne 0 ]; then
	echo "Unable to mktemp!" 1>&2
	exit 1
fi
LOGDIR="%{LOGDIR}"
INSTALL_LOG="${LOGDIR}/install.log"
INSTALL_ERR="${LOGDIR}/install.err"

echo -n "`date +'%b %e %Y %T'`: Updating system library cache..." >${TMPFILE}
/sbin/ldconfig
echo "done." >>${TMPFILE}
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

if [ -e /etc/xinetd.d ] && [ -d /etc/xinetd.d ] ; then
	if [ ! -f /etc/xinetd.d/amandaserver ] ; then
		cp %{AMANDAHOMEDIR}/example/xinetd.amandaserver /etc/xinetd.d/amandaserver
		chmod 0644 /etc/xinetd.d/amandaserver >>${TMPFILE} 2>&1
		if [ -f /etc/xinetd.d/amandaclient ] ; then
			rm /etc/xinetd.d/amandaclient
		fi

		echo -n "`date +'%b %e %Y %T'`: Reloading xinetd configuration..." >${TMPFILE}
		if [ "%{xinetd_reload}" == "reload" ] ; then
			/etc/init.d/xinetd %{xinetd_reload} >>${TMPFILE} 2>&1
			ret_val=$?
			if [ ${ret_val} -ne 0 ] ; then
				echo -n "reload failed.  Attempting restart..." >>${TMPFILE}
				/etc/init.d/xinetd restart >>${TMPFILE} 2>&1
				ret_val=$?
			fi
		else
			/etc/init.d/xinetd %{xinetd_reload} >>${TMPFILE} 2>&1
			ret_val=$?
		fi
		if [ ${ret_val} -eq 0 ] ; then
			echo "success." >>${TMPFILE}
			cat ${TMPFILE}
			cat ${TMPFILE} >>${INSTALL_LOG}
		else
			echo "failed.  Please check your system logs." >>${TMPFILE}
			cat ${TMPFILE} 1>&2
			cat ${TMPFILE} >>${INSTALL_ERR}
		fi
	fi
fi

echo "`date +'%b %e %Y %T'`: Installing '%{SYSCONFDIR}/amandates'." >${TMPFILE}
ret_val=0
if [ ! -f %{SYSCONFDIR}/amandates ] ; then
	touch %{SYSCONFDIR}/amandates >>${TMPFILE} 2>&1
	ret_val=$?
	if [ ${ret_val} -eq 0 ]; then
		echo "`date +'%b %e %Y %T'`: The file '%{SYSCONFDIR}/amandates' has been created." >>${TMPFILE}
	fi
fi
if [ ${ret_val} -eq 0 ]; then
	echo "`date +'%b %e %Y %T'`: Ensuring correct permissions for '%{SYSCONFDIR}/amandates'." >>${TMPFILE}
	chown %{amanda_user}:%{amanda_group} %{SYSCONFDIR}/amandates >>${TMPFILE} 2>&1
	chmod 0640 %{SYSCONFDIR}/amandates >>${TMPFILE} 2>&1
fi
if [ ${ret_val} -eq 0 ]; then
	echo "`date +'%b %e %Y %T'`: '%{SYSCONFDIR}/amandates' Installation successful." >>${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
else
	echo "`date +'%b %e %Y %T'`: '%{SYSCONFDIR}/amandates' Installation failed." >>${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_ERR}
fi

# Install .amandahosts to server
echo "`date +'%b %e %Y %T'`: Checking '%{AMANDAHOMEDIR}/.amandahosts' file." >${TMPFILE}
if [ ! -f %{AMANDAHOMEDIR}/.amandahosts ] ; then
	touch %{AMANDAHOMEDIR}/.amandahosts >>${TMPFILE} 2>&1
fi
for host in localhost localhost.localdomain ; do
	if [ -z "`grep \"^${host}[[:blank:]]\+root[[:blank:]]\+amindexd[[:blank:]]\+amidxtaped\" %{AMANDAHOMEDIR}/.amandahosts`" ] ; then
		echo "${host}   root amindexd amidxtaped" >>%{AMANDAHOMEDIR}/.amandahosts
	fi
	if [ -z "`grep \"^${host}[[:blank:]]\+%{amanda_user}[[:blank:]]\+amdump\" %{AMANDAHOMEDIR}/.amandahosts`" ] ; then
		echo "${host}   %{amanda_user} amdump" >>%{AMANDAHOMEDIR}/.amandahosts
	fi
done
chown %{amanda_user}:%{amanda_group} %{AMANDAHOMEDIR}/.amandahosts >>${TMPFILE} 2>&1
chmod 0600 %{AMANDAHOMEDIR}/.amandahosts >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

# Install amanda client configuration file
echo "`date +'%b %e %Y %T'`: Checking '%{SYSCONFDIR}/amanda/amanda-client.conf' file." >${TMPFILE}
if [ ! -f %{SYSCONFDIR}/amanda/amanda-client.conf ] ; then
	cp %{AMANDAHOMEDIR}/example/amanda-client.conf %{SYSCONFDIR}/amanda/amanda-client.conf >>${TMPFILE} 2>&1
fi
chown %{amanda_user}:%{amanda_group} %{SYSCONFDIR}/amanda/amanda-client.conf >>${TMPFILE} 2>&1
chmod 0600 %{SYSCONFDIR}/amanda/amanda-client.conf >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

# install am_passphrase file to server
echo "`date +'%b %e %Y %T'`: Checking '%{AMANDAHOMEDIR}/.am_passphrase' file." >${TMPFILE}
if [ ! -f %{AMANDAHOMEDIR}/.am_passphrase ] ; then
	echo "`date +'%b %e %Y %T'`: Create '%{AMANDAHOMEDIR}/.am_passphrase' file." >${TMPFILE}
	touch %{AMANDAHOMEDIR}/.am_passphrase >>${TMPFILE} 2>&1
	phrase=`echo "amandabackup" | md5sum | awk '{print $1}'`
	echo ${phrase} >>%{AMANDAHOMEDIR}/.am_passphrase

	chown %{amanda_user}:%{amanda_group} %{AMANDAHOMEDIR}/.am_passphrase >>${TMPFILE} 2>&1
	chmod 0700 %{AMANDAHOMEDIR}/.am_passphrase >>${TMPFILE} 2>&1
fi
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

# Install .gnupg directory
echo "`date +'%b %e %Y %T'`: Installing '%{AMANDAHOMEDIR}/.gnupg'." >${TMPFILE}
ret_val=0
if [ ! -d %{AMANDAHOMEDIR}/.gnupg ] ; then
	echo "`date +'%b %e %Y %T'`: '%{AMANDAHOMEDIR}/.gnupg' will be created." >>${TMPFILE}
	mkdir -p %{AMANDAHOMEDIR}/.gnupg >>${TMPFILE} 2>&1
	ret_val=$?
	if [ ${ret_val} -eq 0 ]; then
		echo "`date +'%b %e %Y %T'`: The directory '%{AMANDAHOMEDIR}/.gnupg' created successfully." >>${TMPFILE}
	else
		echo "`date +'%b %e %Y %T'`: The directory '%{AMANDAHOMEDIR}/.gnupg' creation failed." >>${TMPFILE}
	fi
fi
if [ ${ret_val} -eq 0 ]; then
	echo "`date +'%b %e %Y %T'`: Ensuring correct permissions for '%{SYSCONFDIR}/.gnupg'." >>${TMPFILE}
	chown %{amanda_user}:%{amanda_group} %{AMANDAHOMEDIR}/.gnupg >>${TMPFILE} 2>&1
	ret_val=$?
	if [ ${ret_val} -eq 0 ]; then
		chmod 700 %{AMANDAHOMEDIR}/.gnupg >>${TMPFILE} 2>&1
		ret_val=$?
	fi
fi
if [ ${ret_val} -eq 0 ]; then
	echo "`date +'%b %e %Y %T'`: '%{AMANDAHOMEDIR}/.gnupg' Installation successful." >>${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
else
	echo "`date +'%b %e %Y %T'`: '%{AMANDAHOMEDIR}/.gnupg' Installation failed." >>${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_ERR}
fi

# SSH RSA key generation on server for amdump
KEYDIR="%{AMANDAHOMEDIR}/.ssh"
KEYFILE="id_rsa_amdump"
COMMENT="%{amanda_user}@server"
if [ ! -d ${KEYDIR} ] ; then
	if [ -f ${KEYDIR} ] ; then
		echo "`date +'%b %e %Y %T'`: Directory '${KEYDIR}' exists as a file.  Renaming to '${KEYDIR}.rpmsave'." >${TMPFILE}
		mv ${KEYDIR} ${KEYDIR}.rpmsave >>${TMPFILE} 2>&1
		cat ${TMPFILE}
		cat ${TMPFILE} >>${INSTALL_LOG}
	fi
	echo "`date +'%b %e %Y %T'`: Creating directory '${KEYDIR}'." >${TMPFILE}
	mkdir -p ${KEYDIR} >>${TMPFILE} 2>&1
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi
if [ ! -f ${KEYDIR}/${KEYFILE} ] ; then
	echo "`date +'%b %e %Y %T'`: Creating ssh RSA key in '${KEYDIR}/${KEYFILE}'" >${TMPFILE}
	ssh-keygen -q -C $COMMENT -t rsa -f ${KEYDIR}/${KEYFILE} -N '' >>${TMPFILE} 2>&1
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi
echo "`date +'%b %e %Y %T'`: Setting ownership and permissions for '${KEYDIR}' and '${KEYDIR}/${KEYFILE}*'" >${TMPFILE}
chown %{amanda_user}:%{amanda_group} ${KEYDIR} ${KEYDIR}/${KEYFILE}* >>${TMPFILE} 2>&1
chmod 0750 ${KEYDIR} >>${TMPFILE} 2>&1
chmod 0600 ${KEYDIR}/${KEYFILE}* >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

# SSH RSA key generation on client for amrecover
KEYDIR="%{AMANDAHOMEDIR}/.ssh"
KEYFILE="id_rsa_amrecover"
COMMENT="root@client"
if [ ! -d ${KEYDIR} ] ; then
	if [ -f ${KEYDIR} ] ; then
		echo "`date +'%b %e %Y %T'`: Directory '${KEYDIR}' exists as a file.  Renaming to '${KEYDIR}.rpmsave'." >${TMPFILE}
		mv ${KEYDIR} ${KEYDIR}.rpmsave >>${TMPFILE} 2>&1
		cat ${TMPFILE}
		cat ${TMPFILE} >>${INSTALL_LOG}
	fi
	echo "`date +'%b %e %Y %T'`: Creating directory '${KEYDIR}'." >${TMPFILE}
	mkdir -p ${KEYDIR} >>${TMPFILE} 2>&1
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi
if [ ! -f ${KEYDIR}/${KEYFILE} ] ; then
	echo "`date +'%b %e %Y %T'`: Creating ssh RSA key in '${KEYDIR}/${KEYFILE}'" >${TMPFILE}
	ssh-keygen -q -C $COMMENT -t rsa -f ${KEYDIR}/${KEYFILE} -N '' >>${TMPFILE} 2>&1
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi
echo "`date +'%b %e %Y %T'`: Setting ownership and permissions for '${KEYDIR}'" >${TMPFILE}
chown %{amanda_user}:%{amanda_group} ${KEYDIR} >>${TMPFILE} 2>&1
chmod 0750 ${KEYDIR} >>${TMPFILE} 2>&1
chmod 0600 ${KEYDIR}/${KEYFILE}* >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

# environment variables (~amandabackup/.profile)
echo "`date +'%b %e %Y %T'`: Checking for '%{AMANDAHOMEDIR}/.profile' and ensuring correct environment." >${TMPFILE}
if [ ! -f %{AMANDAHOMEDIR}/.profile ] ; then
	touch %{AMANDAHOMEDIR}/.profile >>${TMPFILE} 2>&1
fi
if [ -z "`grep PATH %{AMANDAHOMEDIR}/.profile | grep '%{SBINDIR}'`" ] ; then
	echo "export PATH=\"\$PATH:%{SBINDIR}\"" >>%{AMANDAHOMEDIR}/.profile 2>>${TMPFILE}
fi
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

echo "`date +'%b %e %Y %T'`: Setting ownership and permissions for '%{AMANDAHOMEDIR}/.profile'" >${TMPFILE}
chown %{amanda_user}:%{amanda_group} %{AMANDAHOMEDIR}/.profile >>${TMPFILE} 2>&1
chmod 0640 %{AMANDAHOMEDIR}/.profile >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

echo "`date +'%b %e %Y %T'`: === Amanda Enterprise backup server installation complete. ===" >${TMPFILE}

cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

if [ -f "${TMPFILE}" ]; then
	rm -f "${TMPFILE}" >>${TMPFILE} 2>&1
fi

echo "Amanda installation log can be found in '${INSTALL_LOG}' and errors (if any) in '${INSTALL_ERR}'."
%postun backup_server
/sbin/ldconfig
%pre backup_client
TMPFILE=`mktemp /tmp/rpm-amanda_enterprise.XXXXXXXXXXX`
if [ $? -ne 0 ]; then
	echo "Unable to mktemp!" 
	exit 1
fi
LOGDIR="%{LOGDIR}"
INSTALL_LOG="${LOGDIR}/install.log"
INSTALL_ERR="${LOGDIR}/install.err"

echo "`date +'%b %e %Y %T'`: Preparing to install: %{amanda_version_info}" >${TMPFILE}

# Check for the 'amanda' user
echo "`date +'%b %e %Y %T'`: Checking for '%{amanda_user}' user..." >>${TMPFILE}
if [ "`id -u %{amanda_user} > /dev/null 2>&1 && echo 0 || echo 1`" != "0" ] ; then
	useradd -c "Amanda" -g disk -d %{AMANDAHOMEDIR} -s /bin/sh %{amanda_user} >>${TMPFILE} 2>&1
	if [ %{dist} = "SuSE" ]; then	
		PASSWD_EXIT=$?
	else
		# Lock the amanda account until admin sets password
		passwd -l %{amanda_user} >>/dev/null
		PASSWD_EXIT=$?
	fi
	if [ ${PASSWD_EXIT} -eq 0 ] ; then
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  The '%{amanda_user}; user account has been successfully created." >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  Furthermore, the account has been automatically locked for you" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  for security purposes.  Once a password for the  '%{amanda_user}'" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  account has been set, the user can be unlocked by issuing" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  the following command as root.:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  # passwd -u %{amanda_user}" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  If this is not a new installation of Amanda and you have" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  pre-existing Amanda configurations in %{SYSCONFDIR}/amanda" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  you should ensure that 'dumpuser' is set to '%{amanda_user}'" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  in those configurations.  Additionally, you should ensure" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  that %{AMANDAHOMEDIR}/.amandahosts on your client systems" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  is properly configured to allow connections for the user" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  '%{amanda_user}'." >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		PASSWD_OK=0
	else
		echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!                                                       !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  The '%{amanda_user}' user account for this system has been   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  created, however the user has no password set. For   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  security purposes this account  is normally locked   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  after creation.  Unfortunately,  when locking this   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  account an error occurred.  To ensure the security   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  of your system  you should set a password  for the   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  user account '%{amanda_user}' immediately!  To set  such a   !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!  password, please issue the following command.:       !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!                                                       !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!   # passwd %{amanda_user}                                     !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!!                                                       !!!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
		PASSWD_OK=1
	fi
else
	# log information about 'amanda' user parameters
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  The Amanda backup software is configured to operate as the" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  user '%{amanda_user}'.  This user exists on your system and has not" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  been modified.  To ensure that Amanda functions properly," >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  please see that the following parameters are set for that" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  user.:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  SHELL:          /bin/sh" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  HOME:           %{AMANDAHOMEDIR}" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  Default group:  %{amanda_group}" >>${TMPFILE}
       		echo "`date +'%b %e %Y %T'`:  Verifying %{amanda_user} parameters :" >>${TMPFILE}

        if [ "`id -gn %{amanda_user}`" != "disk" ] ; then
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! user 'amandabackup' is not part of the disk group,Pl  !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! make sure it is corrected before start using Amanda   !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
        else
                echo "`date +'%b %e %Y %T'`:  Verified group name of user 'amandabackup'" >>${TMPFILE}
        fi

        if [ "`grep ^%{amanda_user} /etc/passwd|cut -d: -f7`" != "/bin/sh" ] ; then
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! user 'amandabackup' default shell should be set to    !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! /bin/sh, pl correct before start using Amanda         !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
        else
                echo "`date +'%b %e %Y %T'`:  Verified Default shell for user 'amandabackup'" >>${TMPFILE}
        fi

        if [ "`grep ^%{amanda_user} /etc/passwd|cut -d: -f6`" != "%{AMANDAHOMEDIR}" ] ; then
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! user 'amandabackup' home directory should be set to   !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! %{AMANDAHOMEDIR} Pl correct before using Amanda       !!!" >>${TMPFILE}
                echo "`date +'%b %e %Y %T'`:  !!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!" >>${TMPFILE}
        else
                echo "`date +'%b %e %Y %T'`:  Verified Default home directory for user amandabackup" >>${TMPFILE}
        fi
	echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}
	PASSWD_OK=0
fi
if [ -d %{AMANDAHOMEDIR} ] ; then
	echo -n "`date +'%b %e %Y %T'`:  Checking ownership of '%{AMANDAHOMEDIR}'... " >>${TMPFILE}
	if [ "`ls -dl %{AMANDAHOMEDIR} | awk '//{split($_,x); print x[3]}'`" = "%{amanda_user}" ] && \
	   [ "`ls -dl %{AMANDAHOMEDIR} | awk '//{split($_,x); print x[4]}'`" = "%{amanda_group}" ] ; then
		echo "correct." >>${TMPFILE}
		VARLIB_OK=0
	else
		echo "incorrect!" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  Please ensure that the directory '%{AMANDAHOMEDIR}' is owned by" >>${TMPFILE}
		echo "`date +'%b %e %Y %T'`:  the user '%{amanda_user}' and group '%{amanda_group}'." >>${TMPFILE}
		VARLIB_OK=1
	fi
else
	VARLIB_OK=0
fi
echo "`date +'%b %e %Y %T'`:" >>${TMPFILE}

if [ ! -e ${LOGDIR} ] ; then
	# create log directory
	mkdir -p -m 0750 ${LOGDIR} >>${TMPFILE} 2>&1
	chown %{amanda_user}:%{amanda_group} ${LOGDIR} >>${TMPFILE} 2>&1
elif [ ! -d ${LOGDIR} ] ; then
	mv ${LOGDIR} ${LOGDIR}.rpmsave >>${TMPFILE} 2>&1
	mkdir -p -m 0750 ${LOGDIR} >>${TMPFILE} 2>&1
	chown %{amanda_user}:%{amanda_group} ${LOGDIR} >>${TMPFILE} 2>&1
	mv ${LOGDIR}.rpmsave ${LOGDIR}/ >>${TMPFILE} 2>&1
fi
if [ ${PASSWD_OK} -eq 1 ] || [ ${VARLIB_OK} -eq 1 ] ; then
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_ERR}
	echo "Please review '${INSTALL_ERR}' to correct errors which have prevented the Amanda installaton." >&2
	echo "Amanda installation log can be found in '${INSTALL_LOG}' and errors (if any) in '${INSTALL_ERR}'."
	exit 1
else
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi

echo "`date +'%b %e %Y %T'`: === Amanda Enterprise backup client installation started. ===" >${TMPFILE}

cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

if [ -f "${TMPFILE}" ]; then
	rm -f "${TMPFILE}"
fi

%post backup_client
TMPFILE=`mktemp /tmp/rpm-amanda_enterprise.XXXXXXXXXXX`
if [ $? -ne 0 ]; then
	echo "Unable to mktemp!" 1>&2
	exit 1
fi
LOGDIR="%{LOGDIR}"
INSTALL_LOG="${LOGDIR}/install.log"
INSTALL_ERR="${LOGDIR}/install.err"

echo -n "`date +'%b %e %Y %T'`: Updating system library cache..." >${TMPFILE}
/sbin/ldconfig
echo "done." >>${TMPFILE}
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

if [ -e /etc/xinetd.d ] && [ -d /etc/xinetd.d ] ; then
	if [ ! -f /etc/xinetd.d/amandaclient ] ; then
		#cp %{AMANDAHOMEDIR}/example/xinetd.amandaclient /etc/xinetd.d/amandaclient

		echo -n "`date +'%b %e %Y %T'`: Reloading xinetd configuration..." >${TMPFILE}
		if [ "%{xinetd_reload}" == "reload" ] ; then
			/etc/init.d/xinetd %{xinetd_reload} >>${TMPFILE} 2>&1
			ret_val=$?
			if [ ${ret_val} -ne 0 ] ; then
				echo -n "reload failed.  Attempting restart..." >>${TMPFILE}
				/etc/init.d/xinetd restart >>${TMPFILE} 2>&1
				ret_val=$?
			fi
		else
			/etc/init.d/xinetd %{xinetd_reload} >>${TMPFILE} 2>&1
			ret_val=$?
		fi
		if [ ${ret_val} -eq 0 ] ; then
			echo "success." >>${TMPFILE}
			cat ${TMPFILE}
			cat ${TMPFILE} >>${INSTALL_LOG}
		else
			echo "failed.  Please check your system logs." >>${TMPFILE}
			cat ${TMPFILE}
			cat ${TMPFILE} >>${INSTALL_LOG}
		fi
	fi
fi

echo "`date +'%b %e %Y %T'`: Installing '%{SYSCONFDIR}/amandates'." >${TMPFILE}
ret_val=0
if [ ! -f %{SYSCONFDIR}/amandates ] ; then
	touch %{SYSCONFDIR}/amandates >>${TMPFILE} 2>&1
	ret_val=$?
	if [ ${ret_val} -eq 0 ]; then
		echo "`date +'%b %e %Y %T'`: The file '%{SYSCONFDIR}/amandates' has been created." >>${TMPFILE}
	fi
fi
if [ ${ret_val} -eq 0 ]; then
	echo "`date +'%b %e %Y %T'`: Ensuring correct permissions for '%{SYSCONFDIR}/amandates'." >>${TMPFILE}
	chown %{amanda_user}:%{amanda_group} %{SYSCONFDIR}/amandates >>${TMPFILE} 2>&1
	chmod 0640 %{SYSCONFDIR}/amandates >>${TMPFILE} 2>&1
fi
if [ ${ret_val} -eq 0 ]; then
	echo "`date +'%b %e %Y %T'`: '%{SYSCONFDIR}/amandates' Installation successful." >>${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
else
	echo "`date +'%b %e %Y %T'`: '%{SYSCONFDIR}/amandates' Installation failed." >>${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_ERR}
fi

# Install .amandahosts to client
echo "`date +'%b %e %Y %T'`: Checking '%{AMANDAHOMEDIR}/.amandahosts' file." >${TMPFILE}
if [ ! -f %{AMANDAHOMEDIR}/.amandahosts ] ; then
	touch %{AMANDAHOMEDIR}/.amandahosts >>${TMPFILE} 2>&1
fi
for host in localhost localhost.localdomain ; do
		if [ -z "`grep \"^${host}[[:blank:]]\+%{amanda_user}[[:blank:]]\+amdump\" %{AMANDAHOMEDIR}/.amandahosts`" ] ; then
			echo "${host}   %{amanda_user} amdump" >>%{AMANDAHOMEDIR}/.amandahosts
		fi
done
chown %{amanda_user}:%{amanda_group} %{AMANDAHOMEDIR}/.amandahosts >>${TMPFILE} 2>&1
chmod 0600 %{AMANDAHOMEDIR}/.amandahosts >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}
### amdump

touch %{SYSCONFDIR}/dumpdates
chown %{amanda_user}:%{amanda_group} %{SYSCONFDIR}/dumpdates

# Install amanda client configuration file
echo "`date +'%b %e %Y %T'`: Checking '%{SYSCONFDIR}/amanda/amanda-client.conf' file." >${TMPFILE}
if [ ! -f %{SYSCONFDIR}/amanda/amanda-client.conf ] ; then
	cp %{AMANDAHOMEDIR}/example/amanda-client.conf %{SYSCONFDIR}/amanda/amanda-client.conf >>${TMPFILE} 2>&1
fi
chown %{amanda_user}:%{amanda_group} %{SYSCONFDIR}/amanda/amanda-client.conf >>${TMPFILE} 2>&1
chmod 0600 %{SYSCONFDIR}/amanda/amanda-client.conf >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

# Install .gnupg directory
echo "`date +'%b %e %Y %T'`: Installing '%{AMANDAHOMEDIR}/.gnupg'." >${TMPFILE}
ret_val=0
if [ ! -d %{AMANDAHOMEDIR}/.gnupg ] ; then
	echo "`date +'%b %e %Y %T'`: '%{AMANDAHOMEDIR}/.gnupg' will be created." >>${TMPFILE}
	mkdir -p %{AMANDAHOMEDIR}/.gnupg >>${TMPFILE} 2>&1
	ret_val=$?
	if [ ${ret_val} -eq 0 ]; then
		echo "`date +'%b %e %Y %T'`: The directory '%{AMANDAHOMEDIR}/.gnupg' created successfully." >>${TMPFILE}
	else
		echo "`date +'%b %e %Y %T'`: The directory '%{AMANDAHOMEDIR}/.gnupg' creation failed." >>${TMPFILE}
	fi
fi
if [ ${ret_val} -eq 0 ]; then
	echo "`date +'%b %e %Y %T'`: Ensuring correct permissions for '%{SYSCONFDIR}/.gnupg'." >>${TMPFILE}
	chown %{amanda_user}:%{amanda_group} %{AMANDAHOMEDIR}/.gnupg >>${TMPFILE} 2>&1
	ret_val=$?
	if [ ${ret_val} -eq 0 ]; then
		chmod 700 %{AMANDAHOMEDIR}/.gnupg >>${TMPFILE} 2>&1
		ret_val=$?
	fi
fi
if [ ${ret_val} -eq 0 ]; then
	echo "`date +'%b %e %Y %T'`: '%{AMANDAHOMEDIR}/.gnupg' Installation successful." >>${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
else
	echo "`date +'%b %e %Y %T'`: '%{AMANDAHOMEDIR}/.gnupg' Installation failed." >>${TMPFILE}
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_ERR}
fi

# SSH RSA key generation on client for amrecover
KEYDIR="%{AMANDAHOMEDIR}/.ssh"
KEYFILE="id_rsa_amrecover"
COMMENT="root@client"
if [ ! -d ${KEYDIR} ] ; then
	if [ -f ${KEYDIR} ] ; then
		echo "`date +'%b %e %Y %T'`: Directory '${KEYDIR}' exists as a file.  Renaming to '${KEYDIR}.rpmsave'." >${TMPFILE}
		mv ${KEYDIR} ${KEYDIR}.rpmsave >>${TMPFILE} 2>&1
		cat ${TMPFILE}
		cat ${TMPFILE} >>${INSTALL_LOG}
	fi
	echo "`date +'%b %e %Y %T'`: Creating directory '${KEYDIR}'." >${TMPFILE}
	mkdir -p ${KEYDIR} >>${TMPFILE} 2>&1
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi
if [ ! -f ${KEYDIR}/${KEYFILE} ] ; then
	echo "`date +'%b %e %Y %T'`: Creating ssh RSA key in '${KEYDIR}/${KEYFILE}'" >${TMPFILE}
	ssh-keygen -q -C $COMMENT -t rsa -f ${KEYDIR}/${KEYFILE} -N '' >>${TMPFILE} 2>&1
	cat ${TMPFILE}
	cat ${TMPFILE} >>${INSTALL_LOG}
fi
echo "`date +'%b %e %Y %T'`: Setting permissions for '${KEYDIR}' and '${KEYDIR}/${KEYFILE}*'" >${TMPFILE}
chown %{amanda_user}:%{amanda_group} ${KEYDIR} >>${TMPFILE} 2>&1
chmod 0750 ${KEYDIR} >>${TMPFILE} 2>&1
chmod 0600 ${KEYDIR}/${KEYFILE}* >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

# environment variables (~amandabackup/.profile)
echo "`date +'%b %e %Y %T'`: Checking for '%{AMANDAHOMEDIR}/.profile' and ensuring correct environment." >${TMPFILE}
if [ ! -f %{AMANDAHOMEDIR}/.profile ] ; then
	touch %{AMANDAHOMEDIR}/.profile >>${TMPFILE} 2>&1
fi
if [ -z "`grep PATH %{AMANDAHOMEDIR}/.profile | grep '%{SBINDIR}'`" ] ; then
	echo "export PATH=\"\$PATH:%{SBINDIR}\"" >>%{AMANDAHOMEDIR}/.profile
fi
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}
echo "`date +'%b %e %Y %T'`: Setting ownership and permissions for '%{AMANDAHOMEDIR}/.profile'" >${TMPFILE}
chown %{amanda_user}:%{amanda_group} %{AMANDAHOMEDIR}/.profile >>${TMPFILE} 2>&1
chmod 0640 %{AMANDAHOMEDIR}/.profile >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

echo "`date +'%b %e %Y %T'`: Creating en_ZM locale"  >>${TMPFILE}
localedef -i /usr/share/i18n/locales/en_US -f ISO-8859-1 en_ZM >>${TMPFILE} 2>&1
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}


echo "`date +'%b %e %Y %T'`: === Amanda Enterprise backup client installation complete. ===" >${TMPFILE}
cat ${TMPFILE}
cat ${TMPFILE} >>${INSTALL_LOG}

if [ -f "${TMPFILE}" ]; then
	rm -f "${TMPFILE}"
fi

echo "Amanda installation log can be found in '${INSTALL_LOG}' and errors (if any) in '${INSTALL_ERR}'."
%postun backup_client
/sbin/ldconfig

# --- Files to install ---

%files backup_client
%defattr(0755,%{amanda_user},%{amanda_group})
%dir %{SYSCONFDIR}/amanda
%dir %{AMANDAHOMEDIR}
%dir %{AMANDAHOMEDIR}/gnutar-lists
%dir %{LIBEXECDIR}
%{SYSCONFDIR}/xinetd.d/amandaclient
%{AMANDAHOMEDIR}/.amandahosts


%{LIBDIR}/libamanda*
%{LIBDIR}/libamclient*

%{LIBEXECDIR}/amandad
%{LIBEXECDIR}/generic-dumper
%{LIBEXECDIR}/amgtar
%{LIBEXECDIR}/noop
%{LIBEXECDIR}/patch-system
%{LIBEXECDIR}/selfcheck
%{LIBEXECDIR}/sendbackup
%{LIBEXECDIR}/sendsize
%{LIBEXECDIR}/amstar
%{LIBEXECDIR}/versionsuffix
%{SBINDIR}/amplot
%defattr(4750,root,disk)
%{LIBEXECDIR}/calcsize
%{LIBEXECDIR}/killpgrp
%{LIBEXECDIR}/rundump
%{LIBEXECDIR}/runstar
%{LIBEXECDIR}/runtar
%{LIBEXECDIR}/amanda-sh-lib.sh
%defattr(0750,%{amanda_user},%{amanda_group})
%dir %{LOGDIR}
%{SBINDIR}/amaespipe
%{SBINDIR}/amcryp*
%{SBINDIR}/amgpgcrypt
%{SBINDIR}/amoldrecover
%{SBINDIR}/amrecover
%defattr(0644,%{amanda_user},%{amanda_group})
%docdir %{MANDIR}
%{MANDIR}/man5/amanda.conf.5.gz
%{MANDIR}/man5/amanda-client.conf.5.gz
%{MANDIR}/man8/amanda.8.gz
%{MANDIR}/man8/amplot.8.gz
%{MANDIR}/man8/amrecover.8.gz
%{LIBEXECDIR}/amcat.awk
%{LIBEXECDIR}/amplot*
%defattr(0640,%{amanda_user},%{amanda_group})
%{AMANDAHOMEDIR}/amanda-release
%{LOCALSTATEDIR}/lib/amanda/example/xinetd.amandaclient
%{LOCALSTATEDIR}/lib/amanda/example/amanda-client.conf
%{LOCALSTATEDIR}/lib/amanda/example/inetd.conf.amandaclient
%{LOCALSTATEDIR}/lib/amanda/example/amanda.conf


%files backup_server
%defattr(0755,%{amanda_user},%{amanda_group})
%dir %{SYSCONFDIR}/amanda
%dir %{LIBEXECDIR}
%dir %{AMANDAHOMEDIR}
%dir %{AMANDAHOMEDIR}/gnutar-lists
%{LIBDIR}/libamanda*
%{LIBDIR}/libamdevice*
%{LIBDIR}/libamclient*
%{LIBDIR}/libamserver*
%{LIBDIR}/libamtape*
%{LIBDIR}/librestore*
%{LIBEXECDIR}/amandad
%{LIBEXECDIR}/amcleanupdisk
%{LIBEXECDIR}/amidxtaped
%{LIBEXECDIR}/amindexd
%{LIBEXECDIR}/amlogroll
%{LIBEXECDIR}/amtrmidx
%{LIBEXECDIR}/amtrmlog
%{LIBEXECDIR}/chg-lib.sh
%{LIBEXECDIR}/chg-chio
%{LIBEXECDIR}/chg-chs
%{LIBEXECDIR}/chg-disk
%{LIBEXECDIR}/chg-iomega
%{LIBEXECDIR}/chg-juke
%{LIBEXECDIR}/chg-manual
%{LIBEXECDIR}/chg-mcutil
%{LIBEXECDIR}/chg-mtx
%{LIBEXECDIR}/chg-multi
%{LIBEXECDIR}/chg-null
%{LIBEXECDIR}/chg-rait
%{LIBEXECDIR}/chg-rth
%{LIBEXECDIR}/chg-scsi
%{LIBEXECDIR}/chg-zd-mtx
%{LIBEXECDIR}/chunker
%{LIBEXECDIR}/driver
%{LIBEXECDIR}/generic-dumper
%{LIBEXECDIR}/amgtar
%{LIBEXECDIR}/noop
%{LIBEXECDIR}/patch-system
%{LIBEXECDIR}/selfcheck
%{LIBEXECDIR}/sendbackup
%{LIBEXECDIR}/sendsize
%{LIBEXECDIR}/amstar
%{LIBEXECDIR}/taper
%{LIBEXECDIR}/versionsuffix
%{LIBEXECDIR}/amanda-sh-lib.sh
%{SBINDIR}/amaddclient
%{SBINDIR}/amadmin
%{SBINDIR}/amcheckdb
%{SBINDIR}/amcleanup
%{SBINDIR}/amdd
%{SBINDIR}/amdevcheck
%{SBINDIR}/amdump
%{SBINDIR}/amfetchdump
%{SBINDIR}/amflush
%{SBINDIR}/amgetconf
%{SBINDIR}/amlabel
%{SBINDIR}/ammt
%{SBINDIR}/amoverview
%{SBINDIR}/amplot
%{SBINDIR}/amreport
%{SBINDIR}/amrestore
%{SBINDIR}/amrmtape
%{SBINDIR}/amserverconfig
%{SBINDIR}/amstatus
%{SBINDIR}/amtape
%{SBINDIR}/amtapetype
%{SBINDIR}/amtoc
%{SBINDIR}/amverify
%{SBINDIR}/amverifyrun
%{SBINDIR}/zm-support-client
#%{SBINDIR}/activate-devpay
%defattr(4750,root,disk)
%{LIBEXECDIR}/calcsize
%{LIBEXECDIR}/killpgrp
%{LIBEXECDIR}/rundump
%{LIBEXECDIR}/runstar
%{LIBEXECDIR}/runtar
%{LIBEXECDIR}/dumper
%{LIBEXECDIR}/planner
%{SBINDIR}/amcheck
%defattr(0750,%{amanda_user},%{amanda_group})
%dir %{LOGDIR}
%{SBINDIR}/amaespipe
%{SBINDIR}/amcrypt
%{SBINDIR}/amcrypt-ossl
%{SBINDIR}/amcrypt-ossl-asym
%{SBINDIR}/amcryptsimple
%{SBINDIR}/amgpgcrypt
%{SBINDIR}/amoldrecover
%{SBINDIR}/amrecover
%defattr(0644,%{amanda_user},%{amanda_group})
%{LIBEXECDIR}/amcat.awk
%{LIBEXECDIR}/amplot.awk
%{LIBEXECDIR}/amplot.g
%{LIBEXECDIR}/amplot.gp
%docdir %{MANDIR}
%{MANDIR}/man5/amanda.conf.5.gz
%{MANDIR}/man5/amanda-client.conf.5.gz
%{MANDIR}/man8/amaddclient.8.gz
%{MANDIR}/man8/amadmin.8.gz
%{MANDIR}/man8/amanda.8.gz
%{MANDIR}/man8/amcheck.8.gz
%{MANDIR}/man8/amcheckdb.8.gz
%{MANDIR}/man8/amcleanup.8.gz
%{MANDIR}/man8/amdd.8.gz
%{MANDIR}/man8/amdump.8.gz
%{MANDIR}/man8/amfetchdump.8.gz
%{MANDIR}/man8/amflush.8.gz
%{MANDIR}/man8/amgetconf.8.gz
%{MANDIR}/man8/amlabel.8.gz
%{MANDIR}/man8/ammt.8.gz
%{MANDIR}/man8/amoverview.8.gz
%{MANDIR}/man8/amplot.8.gz
%{MANDIR}/man8/amrecover.8.gz
%{MANDIR}/man8/amreport.8.gz
%{MANDIR}/man8/amrestore.8.gz
%{MANDIR}/man8/amrmtape.8.gz
%{MANDIR}/man8/amserverconfig.8.gz
%{MANDIR}/man8/amstatus.8.gz
%{MANDIR}/man8/amtape.8.gz
%{MANDIR}/man8/amtapetype.8.gz
%{MANDIR}/man8/amtoc.8.gz
%{MANDIR}/man8/amverify.8.gz
%{MANDIR}/man8/amverifyrun.8.gz
%{MANDIR}/man8/amcrypt.8.gz
%{MANDIR}/man8/amcrypt-ossl.8.gz
%{MANDIR}/man8/amcrypt-ossl-asym.8.gz
%{MANDIR}/man8/amcryptsimple.8.gz
%{MANDIR}/man8/amgpgcrypt.8.gz
%{MANDIR}/man8/amaespipe.8.gz
%{MANDIR}/man8/amdevcheck.8.gz
%{LOCALSTATEDIR}/lib/amanda/template.d/*
%defattr(0640,%{amanda_user},%{amanda_group})
%{AMANDAHOMEDIR}/amanda-release
%defattr(0644,%{amanda_user},%{amanda_group})
%{LOCALSTATEDIR}/lib/amanda/example/xinetd.amandaserver
%{LOCALSTATEDIR}/lib/amanda/example/label-templates/*.ps
%{LOCALSTATEDIR}/lib/amanda/example/*/*/*

# --- ChangeLog

%changelog
* Thu Oct 20 2011 cs@linux-administrator.com
- added amanda_enterprise-Werror.patch
